﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;


namespace WINDF7CSharp
{
    public partial class Formxypendel : Form
    {

        double _Pendxrmin, _Pendxrmax, _pendoffsxr, _pendoffsyr;
        double _pendt0 = 0.001, _pendoffsx, _pendoffsy;
        double xda, xda1, xwa, xdm, xdm1, xdi, xwi, xri;
        double yda, yda1, ywa, ydm, ydm1, ydi, ywi, yri;
        double dxrmax, dxrmax1s, q0ax, q1ax, q0mx, q1mx, pendposx;
        double dyrmax, dyrmax1s, q0ay, q1ay, q0my, q1my, pendposy;
        double deltaxr, pendposxold, xsoll, xwm, uvx;
        double deltayr, pendposyold, ysoll, ywm, uvy;
        int xyxold, xyyold;
        double xriold, yriold;
        double yript1, xript1;
        double dxrw, dkx, dtn, dkr, xtdm, ytdm, xkrm, ykrm, tna;
        int hilfx, hilfy;
        double xinV, yinV, kxy__, qzae;
        int cntsec = 0, cntcol = 0;
        bool run = false;

        private Stopwatch stopwatch = new Stopwatch();
        private readonly MicroLibrary.MicroTimer _microTimer;

        double _Pendymax = 5.0, _Pendymin = 0.0;

        private Rectangle rectangle;
        private Pen pen;
        Graphics gPB;
        int a = 0;

        Random r = new Random();
        FormMain meinMain;

        #region Constructor
      
        public Formxypendel(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed += new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(onMMTimer1);
            _microTimer.Interval = 6000;
            //stopwatch.Start();
            rectangle = new Rectangle(600, 600, 6, 6);
            pen = new Pen(Color.Red, 5);
            gPB = Graphics.FromHwnd(PaintBox1.Handle);
        }

        #endregion


        #region Initialzation

        private void init()
        { 
            //kxy__ ist Verstärkungsfaktor des xy-Schreibers
         // Version Nuullpunkt links unten
         // DA Ausgang 0...5V  , Reglerroutine aber Original +-10V
         //  kxy__=0.2;   // Verstärkung am Schreiber auf .2V / cm
            _Pendxrmin = -10.0; _Pendxrmax = 10.0; _pendoffsxr = 2.5;  _pendoffsyr = 2.5;
          //{ default für stehendes Pendel }
         dxrmax1s=100;dyrmax1s=100;
         dxrw=0.01;dkx=0.01;dtn=0.01;dkr=0.01;
         //{ Reglerparameter }
         _pendt0=0.006; // fest auf 6 ms
         outputx(_pendoffsxr);outputy(_pendoffsyr);
         q0ax=0;q1ax=0;q0ay=0;q1ay=0;
         xda=0;yda=0;xdm=0;ydm=0;xdm1=0;ydm1=0;xda1=0;yda1=0;
         xwi=0;ywi=0;xri=0;yri=0;
         deltaxr=0;deltayr=0;
         xsoll=0;ysoll=0;yript1=0;ywa=0;xript1=0;xwa=0;
         uvx=0;uvy=0;
         xriold=0;yriold=0;
         pendposyold=0;pendposxold=0;
         q0mx=0;q1mx=0;q0ax=0;q1ax=0;
         q0my=0;q1my=0;q0ay=0;q1ay=0;
         cntsec = 0;
         cntcol = 0;


        }
        #endregion

        private void inputx(ref double x)
        {
            double help = 0;
            meinMain.ADCinput((short)numericUpDownADX.Value, ref help);
           // FormADswitch->ADinputadcV(0, help);
           x = help;
        }

       private void inputy(ref double y)
        {
            double help = 0;
            meinMain.ADCinput((short)numericUpDownADY.Value, ref help);
        //FormADswitch->ADinputadcV(1,help);
            y=help;
        }


       double outxx = 0; // Wird zum Zeichnen des Balkens benutzt

       private void outputx(double y)
       {
           outxx = y;
           if (y > _Pendymax) y = _Pendymax;
           if (y < _Pendymin) y = _Pendymin;
           meinMain.DACoutput(0, y);
           //FormADswitch->ADoutdac(0, y);
       }
       //---------------------------------------------------------------------------

       double outy = 0;  // Wird zum Zeichnen des Balkens benutzt

       void outputy(double y)
       {
           outy = y;
           if (y > _Pendymax) y = _Pendymax;
           if (y < _Pendymin) y = _Pendymin;
           meinMain.DACoutput(1, y);
           //FormADswitch->ADoutdac(1, y);
       }

        private void button1_Click(object sender, EventArgs e)
        {
            label1.Visible=true;
            label2.Visible=true;
            label3.Visible=true;
            button3Accept.Visible=true;
            button3Accept.Focus();
            numericUpDown1.Visible = true;
            numericUpDown2.Visible = true;
            timer1.Enabled=true;
            timer3.Enabled = true;
            outputx(2.5);
            outputy(2.5);
            xyxold = PaintBox1.Width / 2;
            xyyold = PaintBox1.Height / 2;

           // PaintBox1->Canvas->Pen->Color=clRed;
          //  PaintBox1->Canvas->Pen->Width=10;
          //  xyxold=int (PaintBox1->Width/2.0);
          //  xyyold=int (PaintBox1->Height/2.0);
        }


        private void button2Start_Click(object sender, EventArgs e)
        {
            if (run)
            {
                run = false; //Stop
                button2Start.Text = "Start";

                label4.Visible = false;
                labelT0.Visible = false;
                labeldT.Visible = false;
                labeldTmax.Visible = false;

                //timer1.Enabled = false;
                timer2.Enabled = false;
                _microTimer.Start();


            }
            else
            {
                init(); 
                run = true;
                //timer1.Enabled = true;  //Start
                button2Start.Text = "Stop";
                
                stopwatch.Start();
                xyStart2 = stopwatch.ElapsedTicks;
                _microTimer.Start();

                label4.Visible = true;
                dxrmax = dxrmax1s * _pendt0;
                dyrmax = dyrmax1s * _pendt0;
                timer2.Enabled = true;
                //timer1.Enabled = true;

                gPB.FillEllipse(Brushes.Red, PaintBox1.Width / 2, PaintBox1.Height / 2, 10, 10);
                //PaintBox1.Canvas->MoveTo(PaintBox1->Width / 2, PaintBox1->Height / 2);
                //PaintBox1.Canvas->Pen->Width = 2;
                //cntsec = 0;
                labelT0.Visible = true;
                labeldT.Visible = true;
                labeldTmax.Visible = true;
                button4akt.Focus();

            }

        }

        private void button3Accept_Click(object sender, EventArgs e)
        {
            label1.Visible = false;
            label2.Visible = false;
            label3.Visible = false;
            button3Accept.Visible = false;
            timer3.Enabled = false;
            button2Start.Enabled = true;
            button2Start.Focus();
          //  PaintBox1.Canvas.Pen.Width = 2;
            
        }

        private void button4akt_Click(object sender, EventArgs e)
        {
            q0mx = 0.20583; q1mx = -0.15833;
            q0ax = 0.4794; q1ax = -0.4788;
            q0my = 0.20583; q1my = -0.15833;
            q0ay = 0.4794; q1ay = -0.4788;

            button5deakt.Enabled = true;
            button4akt.Enabled = false;
        }

        private void button5dakt_Click(object sender, EventArgs e)
        {
            q0mx = 0; q1mx = 0; q0my = 0; q1my = 0;
            xwa = 0; uvx = 0; ywa = 0; uvy = 0;
            pendposy = 0; pendposx = 0;
            q0ax = 0; q1ax = 0; q0ay = 0; q1ay = 0;
            button5deakt.Enabled = false;
            button4akt.Enabled = true;
        }

        void onMMTimer1(object sender, MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            if (run)  // Lauffähig ab 29.6.2012
            {
                /* dreischleifige Reglerprozedur zum Balancieren */
                //double Start1 = FRT_Display->HRTimeInSec();
                //double End1, End2 = FRT_Display->HRTimeInSec();
                double Start1 = stopwatch.ElapsedTicks;
                double End1 = stopwatch.ElapsedTicks;
                

                xytime2 = xytime2 + End1 - xyStart2;
                xyStart2 = End1;
                //xytime2 = xytime2 + End2 - xyStart2; //period
                //xyStart2 = End2;

                xycnt2++;
                xriold = xri;
                inputx(ref xinV); xinV = xinV - _pendoffsx;
                xda = xsoll - xri;                   // äußerer PI-Regler }
                xwa = xwa + q0ax * xda + q1ax * xda1;
                xdm = xwa - uvx;
                xwi = q0mx * xdm + q1mx * xdm1;        // mittlerer PD-Regler }
                if (xwi >= _Pendxrmax) xwi = _Pendxrmax;    // Begrenzung }
                if (xwi <= -_Pendxrmax) xwi = -_Pendxrmax;
                deltaxr =  0.48 * (xinV - xwi);
                if (deltaxr > dxrmax) deltaxr = dxrmax;
                if (deltaxr < -dxrmax) deltaxr = -dxrmax;
                xri = xri + deltaxr;           //innerer I-Regler zum Stellen Wagen unter Pendel}
                if (xri >= _Pendxrmax) xri = _Pendxrmax;    // Begrenzung }
                if (xri <= _Pendxrmin) xri = _Pendxrmin;
                xript1 = 0.940904 * xript1 + 0.0886434 * xri;    // xri mit Tiefpass K=1.49,T=98.9T0}
                pendposx = xript1 + 9.0 * xinV;
                //hilfx=int (pendposx);  // position in mV }
                uvx = 0.88692 * uvx + 5.65398 * (pendposx - pendposxold);  // speed top with PT1}
                pendposxold = pendposx;
                outputx(xykix*xri + _pendoffsxr);
                // now the y-direction }
                yriold = yri;
                inputy(ref yinV); yinV = yinV - _pendoffsy;
                yda = ysoll - yri;                   // äußerer PI-Regler }
                ywa = ywa + q0ay * yda + q1ay * yda1;
                ydm = ywa - uvy;
                ywi = q0my * ydm + q1my * ydm1;        // mittlerer PD-Regler }
                if (ywi >= _Pendxrmax) ywi = _Pendxrmax;    // Begrenzung }
                if (ywi <= -_Pendxrmax) ywi = -_Pendxrmax;
                deltayr =  0.48 * (yinV - ywi);
                if (deltayr > dyrmax) deltayr = dyrmax;
                if (deltayr < -dyrmax) deltayr = -dyrmax;
                yri = yri + deltayr;           //innerer I-Regler zum Stellen von Wagen unter Pendel}
                if (yri >= _Pendxrmax) yri = _Pendxrmax;    // Begrenzung }
                if (yri <= _Pendxrmin) yri = _Pendxrmin;
                yript1 = 0.940904 * yript1 + 0.0886434 * yri;    // Yri mit Tiefpass K=1.49,T=98.9T0}
                pendposy = yript1 + 6.6 * yinV;
                //hilfy=int (pendposy);  // position in mV }
                uvy = 0.88692 * uvy + 5.65398 * (pendposy - pendposyold);  // speed top with PT1}
                pendposyold = pendposy;
                outputy(xykiy*yri + _pendoffsyr);

                xdm1 = xdm; ydm1 = ydm; yda1 = yda; xda1 = xda;
                // end of interrupt-procedure regler_pendel}
                End1 = stopwatch.ElapsedTicks;
                xytime1 = End1 - Start1;                    //Dauer
                if (xytime1 > xymaxtime) xymaxtime = xytime1;     // maxdauer
            }
            else
            { init(); outputx(_pendoffsxr); outputy(_pendoffsyr); }
        }

        double xykix = 0.162, xykiy = 0.182;

        // für Zeitmessung
        double xytime1, xymaxtime = 0;  // Dauer
        double xyStart2;
        double xytime2 = 0;
        //double xyStart2 = FRT_Display->HRTimeInSec(), xytime2 = 0; //period
        int xycnt2 = 0;

        //private void timer1_Tick(object sender, EventArgs e)
        //{
        //    if (run)
        //    {
        //        /* dreischleifige Reglerprozedur zum Balancieren */
        //        //double Start1 = FRT_Display->HRTimeInSec();
        //        //double End1, End2 = FRT_Display->HRTimeInSec();
        //        double Start1 = stopwatch.ElapsedTicks;
        //        double End1 = stopwatch.ElapsedTicks;
        //        double End2 = stopwatch.ElapsedTicks;

        //        xytime2 = xytime2 + End1 + End2 - xyStart2;
        //        xyStart2 = End2;
        //        //xytime2 = xytime2 + End2 - xyStart2; //period
        //        //xyStart2 = End2;

        //        xycnt2++;
        //        xriold = xri;
        //        inputx(ref xinV); xinV = xinV - _pendoffsx;
        //        xda = xsoll - xri;                   // äußerer PI-Regler }
        //        xwa = xwa + q0ax * xda + q1ax * xda1;
        //        xdm = xwa - uvx;
        //        xwi = q0mx * xdm + q1mx * xdm1;        // mittlerer PD-Regler }
        //        if (xwi >= _Pendxrmax) xwi = _Pendxrmax;    // Begrenzung }
        //        if (xwi <= -_Pendxrmax) xwi = -_Pendxrmax;
        //        deltaxr = xykix * 0.48 * (xinV - xwi);
        //        if (deltaxr > dxrmax) deltaxr = dxrmax;
        //        if (deltaxr < -dxrmax) deltaxr = -dxrmax;
        //        xri = xri + deltaxr;           //innerer I-Regler zum Stellen Wagen unter Pendel}
        //        if (xri >= _Pendxrmax) xri = _Pendxrmax;    // Begrenzung }
        //        if (xri <= _Pendxrmin) xri = _Pendxrmin;
        //        xript1 = 0.940904 * xript1 + 0.0886434 * xri;    // xri mit Tiefpass K=1.49,T=98.9T0}
        //        pendposx = xript1 + 9.0 * xinV;
        //        //hilfx=int (pendposx);  // position in mV }
        //        uvx = 0.88692 * uvx + 5.65398 * (pendposx - pendposxold);  // speed top with PT1}
        //        pendposxold = pendposx;
        //        outputx(xri + _pendoffsxr);
        //        // now the y-direction }
        //        yriold = yri;
        //        inputy(ref yinV); yinV = yinV - _pendoffsy;
        //        yda = ysoll - yri;                   // äußerer PI-Regler }
        //        ywa = ywa + q0ay * yda + q1ay * yda1;
        //        ydm = ywa - uvy;
        //        ywi = q0my * ydm + q1my * ydm1;        // mittlerer PD-Regler }
        //        if (ywi >= _Pendxrmax) ywi = _Pendxrmax;    // Begrenzung }
        //        if (ywi <= -_Pendxrmax) ywi = -_Pendxrmax;
        //        deltayr = xykiy * 0.48 * (yinV - ywi);
        //        if (deltayr > dyrmax) deltayr = dyrmax;
        //        if (deltayr < -dyrmax) deltayr = -dyrmax;
        //        yri = yri + deltayr;           //innerer I-Regler zum Stellen von Wagen unter Pendel}
        //        if (yri >= _Pendxrmax) yri = _Pendxrmax;    // Begrenzung }
        //        if (yri <= _Pendxrmin) yri = _Pendxrmin;
        //        yript1 = 0.940904 * yript1 + 0.0886434 * yri;    // Yri mit Tiefpass K=1.49,T=98.9T0}
        //        pendposy = yript1 + 6.6 * yinV;
        //        //hilfy=int (pendposy);  // position in mV }
        //        uvy = 0.88692 * uvy + 5.65398 * (pendposy - pendposyold);  // speed top with PT1}
        //        pendposyold = pendposy;
        //        outputy(yri + _pendoffsyr);

        //        xdm1 = xdm; ydm1 = ydm; yda1 = yda; xda1 = xda;
        //        // end of interrupt-procedure regler_pendel}
        //        End1 = stopwatch.ElapsedTicks;
        //        xytime1 = End1 - Start1;                    //Dauer
        //        if (xytime1 > xymaxtime) xymaxtime = xytime1;     // maxdauer
        //    }
        //    else
        //    { init(); outputx(_pendoffsxr); outputy(_pendoffsyr); }
        //}



        int xyhelpcnt = 0;
        private void timer2_Tick(object sender, EventArgs e)
        {

            cntsec++; cntcol++;
            label4.Text = (cntsec / 5).ToString() + "sec";
            int pointx = Convert.ToInt32(PaintBox1.Width / 5.0 * outxx);
            int pointy = Convert.ToInt32(PaintBox1.Height / 5.0 * (5.0 - outy));
            gPB.DrawLine(pen, xyxold, xyyold, pointx, pointy);

            if (cntcol == 100)
            {
                pen.Color = Color.FromArgb(r.Next());
                cntcol = 0;
            }

            labeldT.Text = "dT = " + (xytime1 * 1000 / Stopwatch.Frequency).ToString("f6") + " ms";
            labeldTmax.Text = "dTmax = " + (xymaxtime * 1000 / Stopwatch.Frequency).ToString("f6") + " ms";
            if (xycnt2!=0)
            {
                labelT0.Text = "T0 =" + (xytime2 / xycnt2*1000/Stopwatch.Frequency ).ToString("f6") + " ms";
            }
            xycnt2 = 0; xytime2 = 0;
            xyhelpcnt++;
            if (xyhelpcnt == 20) { xyhelpcnt = 0; xymaxtime = 0; }  // reset max-Value            
        }

        private void timer3_Tick(object sender, EventArgs e)
        {
            double x = 0; double y = 0;
            gPB.DrawLine(new Pen(Color.White),(int)(PaintBox1.Width/2.0),(int)(PaintBox1.Height/2.0),xyxold,xyyold);
            inputx(ref x);
            numericUpDown1.Value = (decimal)x;
            //Edit1->Text=FloatToStrF(x,ffFixed,3,2);
            _pendoffsx=x;
             inputy(ref y);
           numericUpDown2.Value = (decimal)y;
            //Edit2->Text=FloatToStrF(y,ffFixed,3,2);
            _pendoffsy=y;

            xyxold=(int)(PaintBox1.Width/2.0+PaintBox1.Width/5.0*x);
            xyyold=(int)(PaintBox1.Height/2.0-PaintBox1.Height/5.0*y);

            gPB.DrawLine(new Pen(Color.Red),(int)(PaintBox1.Width/2.0),(int)(PaintBox1.Height/2.0),xyxold,xyyold);
            //PaintBox1.Invalidate();
        }

        private void Formxypendel_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
            
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            xykix = 0.162 * trackBar2.Value / 100.0;
            label9.Text = xykix.ToString();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            xykiy = 0.182 * trackBar1.Value / 100.0;
            label10.Text = xykiy.ToString();
        }

     
   
        
    }
}

