﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WINDF7CSharp
{
    public partial class FormXWCalc : Form
    {
        FormMain meinMain;
        public FormXWCalc(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        double Dw_start;

        public void deutsch()
        {
            groupBox5.Text = "Frequenzrechner";
            groupBox1.Text = "dB- Rechner";
            label_wStart.Text = "Kreisfrequenz w";
            label_f_Start.Text = "Frequenz in Hz";
            label2.Text = "Y- Wert";
            label1.Text = "Y als Faktor, wenn in dB";
            this.Text = "Frequenz- Rechner für Bodediagramme";


        }
        
        public void Ewstart_Leave(object sender, EventArgs e)
        {
            //Ewstart.Text = Dw_start.ToString("G10");
            meinMain.ConvertToDouble(Ewstart.Text,ref Dw_start );
            Efstart.Text = (Dw_start / 2.0 / Math.PI).ToString("G10");
            if (Dw_start > 0)
                Elogw.Text = Math.Log10(Dw_start).ToString("G10");

        }

        private void Ewstart_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Ewstart_Leave(sender, e);
        }

        private void Efstart_Leave(object sender, EventArgs e)
        {
            double fstart=Dw_start/2.0/Math.PI;
            meinMain.ConvertToDouble(Efstart.Text,ref fstart );
            Dw_start = fstart * 2.0 * Math.PI;
            Ewstart.Text = Dw_start.ToString("G10");
            Elogw.Text = Math.Log10(Dw_start).ToString("G10");
        }

        public void Elogw_Leave(object sender, EventArgs e)
        {

            double ln10 = Math.Log(10);
            double elogw=Math.Log10(Dw_start);
            meinMain.ConvertToDouble(Elogw.Text,ref elogw );
            Dw_start = Math.Exp(elogw * ln10);
            Efstart.Text = (Dw_start / 2.0 / Math.PI).ToString("G10");
            Ewstart.Text = Dw_start.ToString("G10");
        }

        private void Efstart_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Efstart_Leave(sender, e);
        }

        private void Elogw_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) Elogw_Leave(sender, e);
        }

        private void textBox5_Leave(object sender, EventArgs e)
        {
            double inp=0, ln10, db;
            ln10 = Math.Log(10);
            meinMain.ConvertToDouble(textBox5.Text,ref inp);
            db = Math.Log(inp) * 20 / ln10;
            textBoxDB.Text = (db).ToString("G10");

        }

        private void textBox5_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) textBox5_Leave(sender, e);
        }

        public void textBox1_Leave(object sender, EventArgs e)
        {
            double ln10 = Math.Log(10),magnitudeFo=0;
            meinMain.ConvertToDouble(textBoxDB.Text,ref magnitudeFo);
            textBox5.Text = (Math.Exp(ln10 * magnitudeFo / 20)).ToString("G10");
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) textBox1_Leave(sender, e);
        }

        private void FormXWCalc_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
    }
}
