﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

// ab März 2018 fehlerhafte For loop beim Einlesen der RS232- Daten korrigiert

namespace WINDF7CSharp
{
    public partial class FormGPA : Form
    {
        FormMain meinMain;
        string points = " Points";

        public FormGPA(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
        }

        string CRLF = "\r\n";
        string isnowopen = " is now open";
        string startagain = "Start again";

        public void deutsch()
        {
            groupBox1.Text = "Bereinigen der Daten";
            groupBox2.Text = "Serielle RS232-Daten";
            groupBox3.Text = "Konvertierung, Speichern und Zeichnen";
            groupBox4.Text = "Gerätewahl";
            groupBox5.Text = "Phasen- Wrapping";
            labelInfo.Text = "Bitte Taste --> View File dann -->List drücken";
            buttonOpen.Text = "Öffne COM-Port";
            buttonStratRec.Text = "Clear und Starte Empf.";
            buttonConvert.Text = "Konvertiere, speichere und zeichne |F|";
            buttonClean.Text = "Bereinige";
            label1.Text = "Lösche erste Zeilen";
            label2.Text = "Start Zeichen Nr.";
            label3.Text = "Anzahl";
            isnowopen = " ist nun offen";
            startagain = " Neu starten";
            labelOpen.Text = "Kein Port offen";


        }

        
        private void buttonOpen_Click(object sender, EventArgs e)
        {
            if (!serialPort1.IsOpen)serialPort1.Open();
            if(serialPort1.IsOpen)
            {

                buttonStratRec.Enabled = true;
                labelOpen.Text=cbPort.Text+isnowopen;
            }

        }


        private void comboBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            serialPort1.PortName = cbPort.Text;
        }

        private void Check_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }

        }

        private void buttonStratRec_Click(object sender, EventArgs e)
        {
            buttonGPADrawF.Enabled = false;
            buttonGPADrawPhi.Enabled = false;
            if (serialPort1.IsOpen) 
                if (timer1.Enabled)
                {
                    timer1.Enabled = false;
                    buttonStratRec.Text = startagain;
                }
                else
                {
                    timer1.Enabled = true;
                    buttonStratRec.Text = "Stop";
                    textBoxRec.Clear();
                    textBoxPhi.Clear();
                    textBoxMag.Clear();
                    labelInfo.Visible = true;
                }
        }
        
        string inp="";
        
        private void timer1_Tick(object sender, EventArgs e)
        {
           toolStripStatusLabel1.Text = DateTime.Now.ToString();// only to see thats timer is running
           while (serialPort1.BytesToRead > 0)
            {
                    int c = serialPort1.ReadChar();
                    char ch=(char)c;
                    if (ch==',') ch=' ';
                    if (ch == '\r')
                    {
                        textBoxRec.AppendText(inp);
                        inp = "";
                    }
                    inp=inp+ch;
            }
        }

 
 
        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            int help = 0;
            int.TryParse(comboBox1.Text,out help);
            serialPort1.BaudRate = help;
        }

        private void buttonClean_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled) buttonStratRec_Click(sender, e);

            int i,Start=(int)nUPStartChar.Value;
            int nb=(int)nUDNumberChar.Value;            
            for (i = (int)nUPDeletefirstline.Value; i < textBoxRec.Lines.Length; i++)
            {

                int len = textBoxRec.Lines[i].Length;
                if (len>Start+nb)
                  textBoxMag.AppendText(textBoxRec.Lines[i].Substring(Start,nb)+CRLF);
            }
            textBoxRec.Clear();
            for (i = 0; i < textBoxMag.Lines.Length; i++)
                textBoxRec.Text = textBoxMag.Text;
            textBoxMag.Clear();
        }

        private void textBoxMag_TextChanged(object sender, EventArgs e)
        {

        }

        private void radioButton1253_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1253.Checked)
            {
                nUPDeletefirstline.Value = 2;
                nUPStartChar.Value = 5;
                nUDNumberChar.Value = 40;
                pB1253.Visible = true;
                pB1260.Visible = false;
            }
            else
            {
                nUPDeletefirstline.Value = 0;
                nUPStartChar.Value = 0;
                nUDNumberChar.Value = 38;
                pB1253.Visible = false;
                pB1260.Visible = true;
            }

        }

        private void radioButton1260_CheckedChanged(object sender, EventArgs e)
        {
            radioButton1253_CheckedChanged(sender, e);
        }

        private void FormGPA_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void buttonConvert_Click(object sender, EventArgs e)
        {
            string[] outstr = new string[10];
            int i;
            int len = textBoxRec.Lines.Length - 1;
            toolStripProgressBar1.Maximum = len;
            toolStripProgressBar1.Visible = true;
            labelInfo.Visible = false;
            for (i = 0; i < len; i++)
            {
                meinMain.datatools.Str2NString(textBoxRec.Lines[i], ref outstr, ' ');
                textBoxMag.AppendText(outstr[0] + " " + outstr[1] + CRLF);
                textBoxPhi.AppendText(outstr[0] + " " + outstr[2] + CRLF);
                toolStripProgressBar1.Value = i;
                Application.DoEvents();
            }
            meinMain.datatools.Str2NString(textBoxRec.Lines[i], ref outstr, ' ');
            textBoxMag.AppendText(outstr[0] + " " + outstr[1]); // last line without CRLF
            textBoxPhi.AppendText(outstr[0] + " " + outstr[2]);
            toolStripProgressBar1.Visible = false;
            buttonGPADrawF.Enabled = true;
            buttonGPADrawPhi.Enabled = true;
 
            buttonSave_Click(sender, e);
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string file = System.IO.Path.GetFileNameWithoutExtension(saveFileDialog1.FileName);
                string path = System.IO.Path.GetDirectoryName(saveFileDialog1.FileName);
                string newfile = path + "\\" + file + ".gpf";
                System.IO.StreamWriter sw = new System.IO.StreamWriter(newfile);
                foreach (string s in textBoxMag.Lines)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
                newfile = path + "\\" + file + ".gpp";
                System.IO.StreamWriter sw1 = new System.IO.StreamWriter(newfile);
                foreach (string s in textBoxPhi.Lines)
                {
                    sw1.WriteLine(s);
                }
                sw1.Close();
                newfile = path + "\\" + file + ".bdf";
                System.IO.StreamWriter sw2 = new System.IO.StreamWriter(newfile);
                foreach (string s in textBoxRec.Lines)
                {
                    sw2.WriteLine(s);
                }
                sw2.Close();
                buttonGPADrawF_Click(sender, e);

            }
        }

        public void buttonGPADrawF_Click(object sender, EventArgs e)
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = true;//w- axis
            LOa.toptitle =  "GPA Magnitude  " + textBoxMag.Lines.Length.ToString() + "  " + points;
            LOa.bottomtitle = "<------     w=10^x     ---->";
            LOa.legend = "GPA Mag";
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBoxMag, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton29MagGPA.Enabled = true;
                meinMain.ToolButton31PhiGPA.Enabled = true;
                meinMain.BringToFront();
            }
            
        }

        public void buttonGPADrawPhi_Click(object sender, EventArgs e)
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = true;  //w- axis
            LOa.toptitle = "GPA Phase  " + textBoxPhi.Lines.Length.ToString() + "  " + points;
            LOa.bottomtitle = "<------     w=10^x     ---->";
            LOa.legend = "GPA Phi";
            if (rb180.Checked) LOa.phasewrap = "180";
            if (rb270.Checked) LOa.phasewrap = "90";
            if (rbNophwrap.Checked) LOa.phasewrap = "no";
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBoxPhi,ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton29MagGPA.Enabled = true;
                meinMain.ToolButton31PhiGPA.Enabled = true;
                meinMain.BringToFront();
            }
            

        }
    }
}
