using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Printing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;
using matinvert;
using System.IO;

       
 


namespace WINDF7CSharp
{
    //Autoren:
    //Tjorben Leister 161392
    //Stephan Kriemann 166494
    public partial class FormLSOffline : Form
    {

        matinvert1 matinve;
        frmLoadOptions frmLO;

        double t00;  // Calulated T0
        private const int maxn = 400;
        private const int maxgrad = maxn-1;   // maxn aus matinv

        //private void   cleargrid();
        private int    delayint, anzpunktelsoff, mprozls=1;
        private double xmaxL, xminL, ymaxL, yminL;//,sumproz,sumR,deltasum; 
        private double[] a = new double[maxgrad];
        private double[] b = new double[maxgrad];
        private double anfx,anfxr;
        private bool   withb0 = false;
        private double[,] ata = new double[maxgrad, maxgrad]; // aus U_regress

        private String outputcurvewrongtimes = "output curve has wrong times"; 
        private string mdtoolarge=" m + d too large"; 
        private string notavailpoints="Not enough points"; 
        private string Inversiondoesntwork="Inversion does not work";
        private string Ineed2Curves = "I need 2 Curves";

        private const int max2n = maxn*2;
        private const int maxtt = maxn*2;  // aus UnitController  fr kt_aus_tetabo()
        private double[] tt = new double [maxtt];// frher tetals ergebnisvektor max2n aus Unitcontroller
        private String rtypeLS;



        //String tetanotdefined = "teta not defined";
        //String a1mustbenegative = "a1 must be negative";
        //String a2mustbepositive = "a2 must be positive";
        string errorfile = "error in file reading : ";
        string idModel = "Identified Model by LS offline method Prof. Bayerlein Windfc#";
        string NoRTCData = "No RTC Data available";
        string identcurve = "Ident Curve";
        string Calculated = "Calculated";


        FormMain meinMain;

        LoadOpt LOLS = new LoadOpt();
        CHMinMax minmaxLS = new CHMinMax();

        public FormLSOffline(FormMain m)
        {
            InitializeComponent();
            matinve = new matinvert1();
            frmLO = new frmLoadOptions(m);

            meinMain = m;
            chart2D1.clearAll();  // To start with no curves and counter -1
        }


        //bei manchen Objekten kann man keinen Tooltip belegen
        //man kann ihn hchstens statisch einstellen
        //diese Objekte sind auskommentiert
        public void deutsch()
        {

            Inversiondoesntwork = "Inversion klappt nicht";
            notavailpoints = "Nicht genug Punkte";
            outputcurvewrongtimes = "Ausgangssignal hat andere Zeiten";
            mdtoolarge = "m+d zu gro";

            //hier muss ein Objektverweis erfolgen

            this.Text = "Identifikation mittels LS-Offline-Verfahren";
            ButtonOptimize.Text = "Optimierung";
            OKbt1.ToolTipText = "Schliee Fenster und kopiere Werte falls sinnvoll in andere Fenster";
            Cancelbtn2.ToolTipText = "Schliee Fenster und ignoriere Ergebnisse";
            TBLoad.ToolTipText = "Lade Datei mit Streckeneingangsdaten";
            tSBSaveSim.ToolTipText = "Speichere Kurve als .sim- Datei";
            SaveDialog1.Title = "Speichere Resultat als *.sim-Datei";
            OpenDialog1.Title = "Lade Datei mit Messwerten vom Eingangssignal";
            OpenDialog2.Title = "Lade Datei mit Messwerten vom Ausgangssignal";
            TBDrawidentcurve.ToolTipText = "Zeichne Ausgangskurve mit den Werten in F(z) als Reaktion auf Eingangssignal";
            //Chartfx1.ToolTipText = "Rechter Mausklick auf Kurve zeigt Koordinaten/n linker Doppelklick schneidet ab";
            ToolButton6.ToolTipText = "Lade ASCII Datei mit Streckeneingangsdaten";
            ToolButton9.ToolTipText = "Lade ASCII Datei mit Streckeneingangsdaten";
            TBLoadOut.ToolTipText = "Lade Datei mit Streckenausgangsdaten";
            CBb0.Text = "mit bo";
           ButnewOutData.Text = "Berechne neues Xr";
            Lalgo.Text = "Die x(n) sind Eingnge des Modells, die xr(n) die Ausgnge";
            TSCurve.Text = "Kurve";
            idModel = "Identifiziertes Modell durch LS offline Methode Windfc#";
            ProcparBox.Text = "Identifiziertes Modell";
            groupBoxCurve.Text= "Kurvendaten";
            groupBoxIdent.Text="Identifikation";
            buttonClearFz.Text= "Lsche Fz";
            ProcparBox.Text = "Identifiziertes Modell";
            ToolButton4.ToolTipText = "Drucke Daten";
            ToolButton7.ToolTipText = "Drucke Daten";
            ToolButton5.ToolTipText = "Lsche Daten";
            ToolButton8.ToolTipText = "Lsche Daten";
            ToolButton6.ToolTipText = "Lade Daten des Eingangssignales";
            ToolButton9.ToolTipText = "Lade Daten des Ausgangssignales";
            ToolButton10.ToolTipText = "Speichere Daten des Ausgangssignales";
            NoRTCData = "Keine Regler Daten verfgbar";
            identcurve = "Ident. Kurve";
            Calculated = "Berechnet";
            chart2D1.Germanlanguage = true;
            Ineed2Curves = "2 Kurven sind ntig";
        }

 
        private void Cancelbtn2_Click(object sender, EventArgs e)
        {
            //Programm schlieen
            Close();
        }

        private void TBDrawidentcurve_Click(object sender, EventArgs e)
        {//Diese funktion ist erstmal nur test (Tjorben)
            // the digital filter is defined in arrays a,b
            // the input signal xr stands in Chartfx1->Values[i], ThisSerie=0

            double   x, yf, sum, xmittel, outs, lssum, lssumproz;
            int      i, gj, d;
            double[] xein = new double[maxgrad];
            double[] xout = new double[maxgrad];
            double[] poi;


            meinMain.ConvertToDouble(edanfx.Text,ref anfx );
            meinMain.ConvertToDouble(edanfxr.Text,ref anfxr );
            gridtoabLS();
            d = delayint;
            if ((mprozls + d + 1) > maxgrad)
                MessageBox.Show(mdtoolarge);
            else
            {
                if (chart2D1.Counter == 3) chart2D1.clearLast();
                if (chart2D1.Counter == 2)
                {
                    chart2D1.Visible = true;

                    PageControl1.SelectTab("TSCurve");
                    chart2D1.CurveNames[2] = identcurve;
                    sum = 0;         // reset the digital filter 
                    lssum = 0;
                    xmittel = 0;        // for (the least square sum 
                    for (i = 0; i < maxgrad; i++)
                    { xout[i] = 0; xein[i] = 0; }
                    for (gj = 0; gj < anzpunktelsoff; gj++)
                    {

                        poi = chart2D1.getPoint(0, gj);//korr start 0
                        x = poi[0];  /* t */
                        yf = poi[1];        // function values of the model input xr
                        /*digital filter*/
                        for (i = mprozls + d + 1; i > 1; i--)    // Shiften 
                        {
                            xout[i] = xout[i - 1];
                            xein[i] = xein[i - 1];
                        }
                        xout[1] = sum;
                        xein[1] = yf - anfxr;
                        sum = b[0] * xein[1 + d];       // b0*xein(n) 
                        for (i = 1; i <= mprozls; i++)
                        {
                            sum = sum - a[i] * xout[i];      //-ai*alte Ausgnge 
                            sum = sum + b[i] * xein[i + d + 1];    //+bi*Eingang 
                        }
                        /* }  of digital filter algorithm*/
                        if (x > xmaxL) xmaxL = x;
                        if (x < xminL) xminL = x;
                        outs = sum + anfx;
                        chart2D1.setPoint(2, x, outs);
                        if (outs > ymaxL) ymaxL = outs;
                        if (outs < yminL) yminL = outs;
                        // measured curve
                        poi = chart2D1.getPoint(1, gj);//korr start 0
                        yf = poi[1];
                        if ((Math.Abs(outs) > 1e16) || (lssum > 1e30)) /* limit to avoid overflow error*/
                            lssum = 1e30;
                        else lssum = lssum + sqr(yf - outs);
                        xmittel = xmittel + yf;
                    }/*for*/
                    chart2D1.autoScaling();
                    chart2D1.startDrawing();

                    if (xmittel == 0) edlssumproz.Text = "???";
                    else
                    {
                        lssumproz = 100 * Math.Sqrt(lssum / anzpunktelsoff) / xmittel;
                        edlssumproz.Text = (lssumproz).ToString("G8");
                    }
                    edlssum.Text = (lssum).ToString("G8");


                }  /* ;else*/

                else
                    MessageBox.Show(Ineed2Curves);
            }
        }

        private double sqr(double x)
        {
            return (x * x);
        }

        private void gridtoabLS()
        {
            int i;

            meinMain.ConvertToDouble(dataGridView1.Rows[0].Cells[1].Value.ToString(),ref b[0] ); /*bo*/
            for (i = 1; i <= mprozls; i++)
            {
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[0].Value.ToString(),ref a[i] );
                 meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(),ref b[i]);
            } /*for*/

        }

        private void abtogridLS()
        {
            int i;
            cleargrid();

            dataGridView1.Rows[0].Cells[1].Value = b[0].ToString();  /*bo*/
            for (i = 1; i <= mprozls; i++)
            {
                dataGridView1.Rows[i].Cells[0].Value = a[i].ToString();
                dataGridView1.Rows[i].Cells[1].Value = b[i].ToString();
            } /*for*/

        }

        private void cleargrid()
        {
            int i, j;
            
            lrecaltype.Text = "";
            dataGridView1.RowCount = mprozls + 1;
            for (i = 0; i <= mprozls; i++)   /*numbers left*/
                dataGridView1.Rows[i].HeaderCell.Value = i.ToString(); //vllt auch falsch
            for (i = 0; i <= 1; i++)    /* clear grid */
                for (j = 0; j <= mprozls ; j++)
                    dataGridView1.Rows[j].Cells[i].Value = "0";
            dataGridView1.Rows[0].Cells[0].Value = "1"; /*a0 does not exist */

        }

        private double psi(int i, int j, int m, int d) // wird in ls-offline-Identifikation bentigt
        /* to avoid local data array psi */
        {
            int ind;
            double[] poi;
            if (j <= m)
            {   /* fill psi mit old output values (recursive values)*/
                ind = i - j;
                if (ind < 1) return (0);
                else
                {
                    //Measured output x
                    poi = chart2D1.getPoint(1, ind - 1);//korr start 0
                    return (-poi[ 1] + anfx);
                }
            }
            else
            {    /* fill psi mit input values */
                ind = i - j + m;
                 //Input  xr
                if (withb0)
                    if ((ind - d) < 0) return (0);
                    else
                    {
                        poi = chart2D1.getPoint(0, ind - d);//korr start 0
                        return (poi[1] - anfxr);
                    }
                else
                    if ((ind - d) < 1) return (0);
                    else
                    {
                        poi = chart2D1.getPoint(0, ind - d - 1);//korr start 0
                        return (poi[ 1] - anfxr);
                    }
            }
        } /*psi*/

       
        //Da man den Inhalt aus Textboxen nicht einfach drucken kann, 
        //wird in den nchsten beiden Methoden ein kleiner Trick angewandt
        private void ToolButton4_Click(object sender, EventArgs e)
        {
            PrintDocument printDoc = new PrintDocument();
            printDoc.PrintPage += new PrintPageEventHandler(printDoc_PrintPage1);
            PrintDialog pd = new PrintDialog();
            pd.Document = printDoc;
            if (pd.ShowDialog() == DialogResult.OK)
            {
                printDoc.Print();
            } 
        }

        private void printDoc_PrintPage1(object sender, PrintPageEventArgs e)
        {

            String textToPrint = textBox1.Text;
            Font printFont = new Font("Arial", 18, FontStyle.Bold);
            e.Graphics.DrawString(textToPrint, printFont, Brushes.Black, 10, 25);
        }

        private void ToolButton5_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
        }

        private void ToolButton8_Click(object sender, EventArgs e)
        {
            textBox2.Clear();
        }

         private void ButtonOptimize_Click(object sender, EventArgs e)
        {
            int error, i, m, d, n;
            double det=0, kondls=0, x, t0;
            String str;
            int j, k, zweim;
            double[] q = new double[maxn];
            double t1=0, t2=0, kproz=0;
            String err="";
            double[] poi;
            if (chart2D1.Counter < 2)
                MessageBox.Show(Ineed2Curves);

            mprozls = Convert.ToInt32(SpEddegree.Value);
            meinMain.ConvertToDouble(edanfx.Text,ref anfx );
            meinMain.ConvertToDouble(edanfxr.Text,ref anfxr  );
            d = Convert.ToInt32(SpEddelay.Value);  //SpEddelay is hier atm unbekannt
            n = (int)nudUsePoints.Value;
            //++t0=StrToFloat(Edidentto->Text)/1000.0; //t0 in sec
            double t0help = 0;
            meinMain.ConvertToDouble(Edidentto.Text, ref t0help);
            t0 = t0help/ 1000.0; // t0 in sec

            // Identification LS Offline Method


            m = mprozls;

            /* Ausfllen der Matrizen */
            if (withb0) zweim = 2 * m + 1;
            else zweim = 2 * m;

            if (n < zweim) MessageBox.Show(notavailpoints);
            else
            {
                /* Isermann Gl. 24.2.13 */
                for (i = 1; i <= zweim; i++)
                    for (j = 1; j <= zweim; j++)
                    {
                        ata[i - 1, j - 1] = 0;   /* psiT * psi */
                        for (k = 1; k <= n; k++)
                            ata[i - 1, j - 1] = ata[i - 1, j - 1] + psi(k, i, m, d) * psi(k, j, m, d);
                    } /*for (j....*/

                //Im C-Builder gibts ne matinv.h die er imported hat
                error = matinve.matinv(ref ata, zweim, ref det, ref kondls);
                /* Jetzt in psitpsi Matrix P */

                if (error == 0)
                {
                    /* Berechnung von psit*y */
                    for (i = 1; i <= zweim; i++)
                    {
                        q[i] = 0;
                        for (j = 1; j <= n; j++)
                        {
                             //Measured output x
                            poi = chart2D1.getPoint(1, j - 1);//korr start 0
                            x = poi[1];
                            q[i] = q[i] + psi(j, i, m, d) * (x - anfx);
                        }
                    }   /* for (i...*/
                    /* Berechnung von P * (psiT*y) */
                    for (i = 1; i <= zweim; i++)
                    {
                        tt[i] = 0;
                        for (j = 1; j <= zweim; j++)
                        {
                            tt[i] = tt[i] + ata[i - 1, j - 1] * q[j];
                        } /*for (j...*/
                    } /*for (i...*/

                    for (i = 1; i <= m; i++) a[i] = tt[i];

                    if (!withb0)  // without b0
                    {
                        for (i = m; i >= 1; i--)
                        {
                            b[i] = tt[i + m];
                            tt[i + m + 1] = tt[i + m];
                        } /*for (j...*/
                        b[0] = 0; tt[1 + m] = 0; /*b0*/
                    } /*if withb0...*/
                    else // with b0
                        for (i = 1; i <= (m + 1); i++) b[i - 1] = tt[i + m];
                }   /*if*/
                else
                {
                    MessageBox.Show(Inversiondoesntwork + " " + error);
                }  /*;else*/
            }  /*if n>zweim*/



            /* offline_ls */

            abtogridLS();

            TBDrawidentcurve_Click(sender, e);

            //TBStoreFz.Enabled = true;
            for (int ii=0;ii<tt.Length;ii++) tt[ii]=0; //clear tt
            tt[mprozls + 1] = b[0];
            for (i = 1; i <= (mprozls); i++)
            {
                tt[i] = a[i];
                tt[i + 1 + mprozls] = b[i];
            }

            err = " ";
            meinMain.datatools.kt_aus_tetab0(ref kproz, ref t1, ref t2, t0, tt, mprozls, ref rtypeLS, ref err);
            if (err != "") MessageBox.Show(err);
            else
            {
                lrecaltype.Text = rtypeLS;   //
                par1.Text = kproz.ToString();  // 
                par2.Text = t1.ToString();
                par3.Text =t2.ToString();
                lpar2.Visible = false;
                par2.Visible = false;
                lpar3.Visible = false;
                par3.Visible = false;

                if (rtypeLS == "PT2")
                {
                    lpar2.Text = "d";
                    lpar3.Text = "wo";
                    lpar2.Visible = true;
                    par2.Visible = true;
                    lpar3.Visible = true;
                    par3.Visible = true;
                }
                else
                {
                    lpar2.Text = "T1";
                    lpar3.Text = "T2";
                }
                if ((rtypeLS == "IT1") || (rtypeLS == "PT1"))
                {
                    lpar2.Visible = true;
                    par2.Visible = true;
                }
                if (rtypeLS == "2PT1")
                {
                    lpar2.Visible = true;
                    par2.Visible = true;
                    lpar3.Visible = true;
                    par3.Visible = true;
                }
            }

            //bottemlinechart

            str = "";
            for (i = 1; i <= mprozls; i++)
                str = str + "a" + i + "=" + a[i].ToString("G5") + "  ";
            for (i = 0; i <= mprozls; i++)
                str = str + "b" + i + "=" + b[i].ToString("G5") + "  ";

            str = str + lrecaltype.Text + " K=" + par1.Text + "  " + lpar2.Text + "=" + par2.Text +
                                        "  " + lpar3.Text + "=" + par3.Text;
            chart2D1.BottomTitle=str;
        }

        private void ButnewOutData_Click(object sender, EventArgs e)
        {

            // Overwrites 2nd curve copy values into Memo2, will destroy measured datat!!!
            // the digital filter is defined in arrays a,b
            // the input signal xr stands in Chartfx1->Values[i], ThisSerie=0
            //
            double x, yf, sum;
            double[] xein = new double[maxgrad];
            double[] xout = new double[maxgrad];
            int i=0, gj, d;
            double out1;  // out durch out1 ersetzt 
            double [] Poi;


            meinMain.ConvertToDouble(edanfx.Text,ref anfx );
            meinMain.ConvertToDouble(edanfxr.Text,ref anfxr );
            gridtoabLS();
            textBox2.Clear();
            if (chart2D1.Counter == 3) chart2D1.clearLast();
            if (chart2D1.Counter == 2) chart2D1.clearLast();
            d = delayint;
            if ((mprozls + d + 1) > maxgrad) MessageBox.Show(mdtoolarge);
            else
            {
                xmaxL = -1e200; xminL = 1e200;
                yminL = 1e200; ymaxL = -1e200;

                chart2D1.Visible = true;
                PageControl1.SelectTab(TSCurve);
                chart2D1.CurveNames[1] = Calculated;
                sum = 0;         /* reset the digital filter */
                for (i = 0; i < maxgrad; i++)
                {
                    xout[i] = 0;
                    xein[i] = 0;
                }

                for (gj = 0; gj < anzpunktelsoff; gj++)
                {

                    Poi = chart2D1.getPoint(0, gj);//korr start 0
                    x = Poi[ 0];  /* t */
                    yf = Poi[1];        /* function values of the model input xr*/
                    /*digital filter*/
                    for (i = mprozls + d + 1; i > 1; i--)    /* Shiften */
                    {
                        xout[i] = xout[i - 1];
                        xein[i] = xein[i - 1];
                    }
                    xout[1] = sum;
                    xein[1] = yf - anfxr;
                    sum = b[0] * xein[1 + d];       /* b0*xein(n) */
                    for (i = 1; i <= mprozls; i++)
                    {
                        sum = sum - a[i] * xout[i];      /*-ai*alte Ausgnge */
                        sum = sum + b[i] * xein[i + d + 1];    /*+bi*Eingang */
                    }
                    /* }  of digital filter algorithm*/
                    if (x > xmaxL) xmaxL = x;
                    if (x < xminL) xminL = x;
                    out1 = sum + anfx;
                    chart2D1.setPoint(1, x, out1);
                    textBox2.AppendText(x.ToString() + " " + out1.ToString() + "\r\n");
                    if (out1 > ymaxL) ymaxL = out1;
                    if (out1 < yminL) yminL = out1;
                }  /*for*/

                chart2D1.autoScaling();
                chart2D1.startDrawing();
                edlssumproz.Text = "???";
                edlssum.Text = "???";
                TSDataOut.Text = "ASCII Out Calculated";  // Text statt caption
                ButtonOptimize.Enabled = true;

            }  /* ;else*/
        }

 
        //Da man den Inhalt aus Textboxen nicht einfach drucken kann, 
        //wird in den nchsten beiden Methoden ein kleiner Trick angewandt
        private void ToolButton7_Click(object sender, EventArgs e)
        {
            
            PrintDocument printDoc = new PrintDocument();
            printDoc.PrintPage += new PrintPageEventHandler(printDoc_PrintPage2);
            PrintDialog pd = new PrintDialog();
            pd.Document = printDoc;
            if (pd.ShowDialog() == DialogResult.OK)
            {
                printDoc.Print();
            } 
            
        }

        private void printDoc_PrintPage2(object sender, PrintPageEventArgs e)
        {
            
            String textToPrint = textBox2.Text;
            Font printFont = new Font("Arial", 18, FontStyle.Bold);
            e.Graphics.DrawString(textToPrint, printFont, Brushes.Black, 10, 25);
        }

 
        private void ToolButton10_Click(object sender, EventArgs e)
        {
            if (SaveDialog1.ShowDialog() == DialogResult.OK) 
            {
                StreamWriter myStream1 = new StreamWriter(SaveDialog1.OpenFile(), Encoding.Default);
                myStream1.WriteLine(textBox2.Text);
                myStream1.Close();
            }
 
        }

        private void TBLoad_Click(object sender, EventArgs e)
        {   // read in input signal
            double[] poi1 ;
            double[] poi2;
            chart2D1.CurveColor0 = Color.Blue;

            frmLO.ShowDialog();

            if (frmLO.DialogResult == DialogResult.OK)
            {
                minmaxLS.init();
                chart2D1.clearAll();
                LOLS = frmLO.LO1;
                string fn = System.IO.Path.GetFileName(frmLO.openFileDialog1.FileName);
                LOLS.bottomtitle = "input file " + fn;
                LOLS.legend = fn;

                int a = meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, frmLO.textBox1,ref minmaxLS, LOLS);//ConvertTB2Chart(meinm;
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                     textBox1.Text = frmLO.textBox1.Text;
                     anzpunktelsoff = LOLS.nbofpointslastcurve;
                     nudUsePoints.Value = anzpunktelsoff;

                     poi1 = chart2D1.getPoint(0, 0);//korr start 0
                     poi2 = chart2D1.getPoint(0, 1);//korr start 0

                     t00 = (poi2[ 0] - poi1[0]) * 1000.0;
                     Edidentto.Text = t00.ToString();
                     edanfxr.Text = poi1[1].ToString();
                     chart2D1.CurveNames[0] = fn;
                }
            }
        }

        private void TBLoadOut_Click(object sender, EventArgs e)
        {    // read in output signal
            double[] poi1, poi2;
            frmLO.ShowDialog();
            if (frmLO.DialogResult == DialogResult.OK)
            {
                if (chart2D1.Counter == 3) chart2D1.clearLast();
                if (chart2D1.Counter == 2) chart2D1.clearLast();
                LOLS = frmLO.LO1;
                string fn = System.IO.Path.GetFileName(frmLO.openFileDialog1.FileName);
                LOLS.bottomtitle = "output file " + fn;
                LOLS.legend = fn;
                //                minmaxLS.serie = 1; // force to write into 2nd Curve nb 1
                int a = meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, frmLO.textBox1, ref minmaxLS, LOLS);//ConvertTB2Chart(meinm;
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    poi1 = chart2D1.getPoint(1, 0);//korr start 0
                    poi2 = chart2D1.getPoint(1, 1);//korr start 0
                    edanfx.Text = poi1[1].ToString();
                    ButtonOptimize.Enabled = true;
                    textBox2.Text = frmLO.textBox1.Text;
                    chart2D1.CurveNames[1] = fn;
                    if (t00 != ( poi2[0]-poi1[0])*1000.0)
                        MessageBox.Show(outputcurvewrongtimes);

                }
            }
        }

        public double tzLS,t0LS;

        private void OKbt1_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(Edidentto.Text, ref help);
            t0LS = help / 1000.0;  // in sec
           
            meinMain.LSoffOK(rtypeLS);
            // Copy grid values to digital bode plot window

            List<String> pList = new List<String>();

            pList.Add("Identified by LS Offline");
            pList.Add(SpEddegree.Value.ToString());
            pList.Add("1 " + dataGridView1.Rows[0].Cells[1].Value.ToString());
            for (int i = 1; i <= SpEddegree.Value; i++)
            {
                pList.Add(dataGridView1.Rows[i].Cells[0].Value.ToString() + " " + dataGridView1.Rows[i].Cells[1].Value.ToString());
            }
            pList.Add(t0LS.ToString());
            meinMain.fdigfilt.Etz.Text = SpEddelay.Value.ToString();  // Zustzliche Totzeit in n * T0
            meinMain.fdigfilt.copyList2DigitalFilterForm(pList);
            meinMain.ToolButton19SR.Enabled = true;


            Close();
        }

        private void SpEddegree_ValueChanged(object sender, EventArgs e)
        {
            mprozls = (int) SpEddegree.Value;
            cleargrid();
            if (mprozls > 2)
            {
                lpar2.Visible = false;
                lpar3.Visible = false;
                par2.Visible = false;
                par3.Visible = false;
            }
            else
            {
                lpar2.Visible = true;
                lpar3.Visible = true;
                par2.Visible = true;
                par3.Visible = true;
            }; /*;else*/
        }

        private void SpEddelay_ValueChanged(object sender, EventArgs e)
        {
            delayint = (int)SpEddelay.Value;
        }

        private void CBb0_Click(object sender, EventArgs e)
        {
            withb0 = CBb0.Checked;
        }


        private void FormLSOffline_Load(object sender, EventArgs e)
        {
             minmaxLS.init();
        }

        private void FormLSOffline_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        private void buttonSaveFz_Click(object sender, EventArgs e)
        {
            if (SaveDialog2.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add(idModel);
                pList.Add(mprozls.ToString());

                for (int i = 1; i <= mprozls + 1; i++)
                {
                    pList.Add(dataGridView1.Rows[i - 1].Cells[0].Value + " "
                        + dataGridView1.Rows[i - 1].Cells[1].Value);
                }
                double help = 0;
                meinMain.ConvertToDouble(Edidentto.Text, ref help);
                pList.Add(( help/ 1000.0).ToString());  // in edto in msec, in file in sec
                pList.Add("0");  // no integer delay n*T0
                pList.Add("0"); // no continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(SaveDialog2.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }
        }

        private void Bfztodf_Click(object sender, EventArgs e)
        {
            // Load *fz file, fill datastringgrid and try to convert into Pt1, It1 or 2PT1
            List<String> pList = new List<String>();
            double t0 = 0;
            if (OpenDialog3.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(OpenDialog3.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();

                int i;
                int len = pList.Count;
                string[] outstr = new string[10];
                //tBcomment.Text = pList[0];
                //tBcomment.Visible = true;
                int Dmgrad = Convert.ToInt32(pList[1]);
                SpEddegree.Value = Dmgrad;

                tt.Initialize();
                if ((Dmgrad + 4) > len) MessageBox.Show(meinMain.fdigfilt.wrongfileformat);
                else
                {
                    meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');  // a0, b0
                    dataGridView1.Rows[0].Cells[0].Value = outstr[0] ;  //a0
                    dataGridView1.Rows[0].Cells[1].Value = outstr[1] ;  //a0

                   meinMain.ConvertToDouble(outstr[1],ref  tt[Dmgrad + 1] );  // b0

                    for (i = 3; i <= (Dmgrad + 2); i++)
                    {
                        meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                        dataGridView1.Rows[i - 2].Cells[0].Value = outstr[0] ;
                        meinMain.ConvertToDouble(outstr[0],ref tt[i - 2] );  //ai
                        dataGridView1.Rows[i - 2].Cells[1].Value = outstr[1] ;
                        meinMain.ConvertToDouble(outstr[1],ref tt[i - 1 + Dmgrad] );  //bi
                    }
                    meinMain.ConvertToDouble(pList[i],ref t0);
                    //if (len > i + 2)  // some files contains  continuous delay
                    //    if (pList[i + 2] != "") edtt.Text = pList[i + 2];
                    double _K = 0, _T1 = 0, _T2 = 0;
                    string error = "";
                    meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0, tt, Dmgrad, ref rtypeLS, ref error);
                    lrecaltype.Text = "Type=  " + rtypeLS;
                    par1.Text = _K.ToString("G8");
                    par2.Text = _T1.ToString("G8");
                    par3.Text = _T2.ToString("G8");
                    lpar2.Visible = false;
                    par2.Visible = false;
                    lpar3.Visible = false;
                    par3.Visible = false;

                    if (rtypeLS == "PT2")
                    {
                        lpar2.Text = "d";
                        lpar3.Text = "wo";
                        lpar2.Visible = true;
                        par2.Visible = true;
                        lpar3.Visible = true;
                        par3.Visible = true;
                    }
                    else
                    {
                        lpar2.Text = "T1";
                        lpar3.Text = "T2";
                    }
                    if ((rtypeLS == "IT1") || (rtypeLS == "PT1"))
                    {
                        lpar2.Visible = true;
                        par2.Visible = true;
                    }
                    if (rtypeLS == "2PT1")
                    {
                        lpar2.Visible = true;
                        par2.Visible = true;
                        lpar3.Visible = true;
                        par3.Visible = true;
                    }
                }
            }
        }

        private void buttonClearFz_Click(object sender, EventArgs e)
        {
            cleargrid();
        }

 
        public bool rtcDataOK = false;

        private void tSBGetRTC_Click(object sender, EventArgs e)
        {
            TextBox tbpointer = null, tbpointer2 = null;
            double[] poi1, poi2;

            if (meinMain.controlBoxSelector == "adapt")
            {
                tbpointer = meinMain.frmadaptcon.tbLastValuesX;
                tbpointer2 = meinMain.frmadaptcon.tBLastValuesXr;
            }
            else MessageBox.Show(NoRTCData);

            if ((tbpointer != null) && (tbpointer2.Lines.Length > 5) && (tbpointer.Lines.Length > 5))
            {
                minmaxLS.init();  // Read xr- values
                LOLS.init();
                chart2D1.clearAll();
                LOLS.bottomtitle = "RTC- Data ";
                LOLS.legend = "RTC- in-data ";
                textBox1.Text =  tbpointer2.Text;
                int a = meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, textBox1, ref minmaxLS, LOLS);//ConvertTB2Chart(meinm;
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    anzpunktelsoff = LOLS.nbofpointslastcurve;
                    nudUsePoints.Value = anzpunktelsoff;
                    poi1 = chart2D1.getPoint(0, 0);//korr start 0
                    poi2 = chart2D1.getPoint(0, 1);//korr start 0

                    t00 = (poi2[0] - poi1[0]) * 1000.0;
                    Edidentto.Text = t00.ToString();
                    edanfxr.Text =  poi1[1].ToString();
                }

                textBox2.Text =tbpointer.Text;
                LOLS.legend = "RTC- out-data ";
                a = meinMain.datatools.ConvertTB2ChartAdd(ref chart2D1, textBox2, ref minmaxLS, LOLS);//ConvertTB2Chart(meinm;
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    poi1 = chart2D1.getPoint(1, 0);//korr start 0
                    poi2 = chart2D1.getPoint(1, 1);//korr start 0
                    edanfx.Text = poi1[1].ToString();
                    ButtonOptimize.Enabled = true;
                    if (t00 != (poi2[0] - poi1[0]) * 1000.0)
                        MessageBox.Show(outputcurvewrongtimes);
                }
            }
            else MessageBox.Show(NoRTCData);
        }

        private void FormLSOffline_VisibleChanged(object sender, EventArgs e)
        {
            if (this.Visible)
            {
                if (rtcDataOK)
                {
                    tSBGetRTC.Enabled = true;
                }
            }

        }

        private void tSBSaveSim_Click(object sender, EventArgs e)
        {
            meinMain.frmsavecurve.RefToChart2D = chart2D1;
            if (meinMain.frmsavecurve.WindowState == FormWindowState.Minimized)
                meinMain.frmsavecurve.WindowState = FormWindowState.Normal;
            meinMain.frmsavecurve.Show();
            meinMain.frmsavecurve.BringToFront();
        }

     }
}