﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WINDF7CSharp.Init
{
    public partial class FInit : Form
    {
        public FInit()
        {
            InitializeComponent();
            if (File.Exists("initpath.txt"))
            {
                StreamReader readfile = new StreamReader("initpath.txt");
                tBSource.Text = readfile.ReadLine();
                tBDest.Text = readfile.ReadToEnd();
            }
        }

        int cnt = 0;

        private void butCopy_Click(object sender, EventArgs e)
        {
            cnt = 0;
            try
            {
                File.Copy(tBSource.Text + "FormCSIIrap1.cs", tBDest.Text + "FormCSIIrap1.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            try
            {
                File.Copy(tBSource.Text + "FormAdaptiveControl.designer.cs", tBDest.Text + "FormAdaptiveControl.designer.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            try
            {
                File.Copy(tBSource.Text + "FormAdaptiveControl.resx", tBDest.Text + "FormAdaptiveControl.resx", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            try
            {
                File.Copy(tBSource.Text + "FormAdaptiveControl.cs", tBDest.Text + "FormAdaptiveControl.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            try
            {
                File.Copy(tBSource.Text + "FormCSIIrap1.designer.cs", tBDest.Text + "FormCSIIrap1.designer.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            try
            {
                File.Copy(tBSource.Text + "FormCSIIrap1.resx", tBDest.Text + "FormCSIIrap1.resx", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            try
            {
                File.Copy(tBSource.Text + "FormDRTKranregler.cs", tBDest.Text + "FormDRTKranregler.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            try
            {
                File.Copy(tBSource.Text + "FormDRTKranregler.designer.cs", tBDest.Text + "FormDRTKranregler.designer.cs", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            try
            {
                File.Copy(tBSource.Text + "FormDRTKranregler.resx", tBDest.Text + "FormDRTKranregler.resx", true);
                cnt++;
            }
            catch (IOException ex)
            {
                MessageBox.Show("Cant Copy: " + ex.Message, Application.ProductName,
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (cnt == 9) labelOK.Text = "OK 9 files copied";
            else labelOK.Text = "NOT OK!!!";

        }

        private void FInit_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }

        public void deutsch()
        {
            label1.Text = "Pfad des Original- Moduls FormStudControl ohne Stud- Regler";
            label2.Text = "Ziel - Pfad im Projekt";
            butCopy.Text = "Kopiere Dateien und vernichte alle alten Änderungen";
        }

        string curdir="";
        
        private void FInit_Load(object sender, EventArgs e)
        {
            curdir=Directory.GetCurrentDirectory();
            tBCurrDir.Text = curdir.Substring(0,curdir.Length-9);
        }

        private void butUseIt_Click(object sender, EventArgs e)
        {
            tBSource.Text = tBCurrDir.Text + "Init\\";
            tBDest.Text = tBCurrDir.Text + "RealTimeController\\";

        }
    }
}
